#include <stdio.h>

    /* Pomocne funkcije za demo - inicijalizacija i crtanje slika. */

void inicijaliziraj(char ekran[10][17]) {
      /* Samo inicijaliziramo za ispise. */
  int i, j;
  for(i = 0; i < 10; ++i) {
    for(j = 0; j < 17; ++j) {
      ekran[i][j] = '.';
    }
  }
}

void printaj(char ekran[10][17]) {
  int i, j;
  printf("\n");
  for (i = 0; i < 10; ++i) {
    for (j = 0; j < 17; ++j) {
      printf("%c", ekran[i][j]);
    }
    printf("\n");
  }
}

    /* Funkcija za stavljanje novog pravokutnika sa zadanim znakom.
       Koristi se u inicijalizaciji i u (c) dijelu rjesenja. */

void stavi(char ekran[10][17], int pi, int pj, int h, int w, char znak) {
      /* Pretpostavljamo da su koordinate (koje stizu kao argumenti) dobre,
         tj. sva 4 vrha pravokutnika se nalaze unutar zadanog polja! */
  int qi = pi+h-1, qj = pj+w-1;  /* Donji desni vrh. */
  int i, j;
  for(i = pi; i <= qi; ++i) {
    for(j = pj; j <= qj; ++j) {
      ekran[i][j] = znak;
    }
  }
}

    /* ********** Rjesenje ********** */

int moze(char ekran[10][17], int pi, int pj, int h, int w) {
      /* Provjerava moze li se na tu lokaciju staviti
         pravokutnik visine h i sirine w. */
  int qi = pi+h-1, qj = pj+w-1;  /* Donji desni vrh. */
  int i, j;
      /* Provjera je li donji desni vrh unutar matrice. */
  if (qi >= 10 || qj >= 17) return 0;
      /* Provjera pravokutnika. */
  for(i = pi; i <= qi; ++i) {
    for(j = pj; j <= qj; ++j) {
      if (ekran[i][j] != '.')
        return 0;
    }
  }
  return 1;
}

void maksimum(char ekran[10][17], int pi, int pj, int *h, int *w) {
      /* Za dane koordinate pi i pj, trazi pravokutnik
         najvece povrsine kojeg mozemo smjestiti na tu lokaciju.
         Vraca visinu/sirinu tog pravokutnika (ako stane).
         Vraca -1 ako nikakav pravokutnik ne stane na lokaciju. */
  int mh = -1, mw = -1, povrsina = -1;
  int hh, ww;

      /* Petlje za visinu hh i sirinu ww. */
  for (hh = 1; pi+hh-1 < 10; ++hh)
    for (ww = 1; pj+ww-1 < 17; ++ww) {
      if (moze(ekran, pi, pj, hh, ww) && hh*ww > povrsina) {
        povrsina = hh*ww;
        mh = hh;
        mw = ww;
      }
  }

      /* Vrati visinu i sirinu. */
  *h = mh; *w = mw;
  return;
}

void popuni(char ekran[10][17], char znak) {
      /* Pronalazi najveci prostor koji se moze popuniti
         i popunjava ga znakom znak. */

      /* Za svaku lokaciju pi i pj, nalazimo dimenzije
         najveceg pravokutnika kojeg mozemo tamo smjestiti.
         Varijable koje pocinju s max pamte podatke
         za najveci od svih tih pravokutnika. */
  int maxi, maxj, maxh, maxw, maxpov = -1;
  int pi, pj, h, w;
  for (pi = 0; pi < 10; ++pi) {
    for(pj = 0; pj < 17; ++pj) {
      maksimum(ekran, pi, pj, &h, &w);
      if (h == -1 || w == -1)
        continue;
      if (h*w > maxpov) {
        maxi = pi; maxj = pj;
        maxh = h;  maxw = w;  maxpov = h*w;
      }
    }
  }

  if (maxpov != -1) {
    stavi(ekran, maxi, maxj, maxh, maxw, znak);
  }
}

    /* Glavni program za demo. */

int main(void) {
  char ekran[10][17];
  int k, l;

      /* Inicijalizacija za prvu sliku. */
  inicijaliziraj(ekran);
  stavi(ekran, 2, 1, 5, 6, 'x');
  stavi(ekran, 6, 8, 3, 6, 'b');

      /* Slika 1. */
  printf("Pocetno stanje = slika 1:\n");
  printaj(ekran);
  printf("\n");

      /* Pozivi funkcija iz rjesenja zadatka. */
  printf(" moze(ekran, 0, 0, 2, 2) = %d\n",
           moze(ekran, 0, 0, 2, 2));
  printf(" moze(ekran, 0, 0, 3, 2) = %d\n",
           moze(ekran, 0, 0, 3, 2));

  maksimum(ekran, 7, 0, &k, &l);
  printf(" maksimum(ekran, 7, 0, &k, &l): k = %d, l = %d\n", k, l);

  popuni(ekran, '1');

      /* Slika 2. */
  printf("\nStanje nakon popuni(ekran, '1') = slika 2:\n");
  printaj(ekran);

  return 0;
}
