#include <stdio.h>

    /* Pomocne funkcije za demo - inicijalizacija i crtanje slika. */

void inicijaliziraj(char sklad[8][12]) {
      /* Samo inicijaliziramo za ispise. */
  int i, j;
  for(i = 0; i < 8; ++i) {
    for(j = 0; j < 12; ++j) {
      sklad[i][j] = ',';
    }
  }
}

void printaj(char sklad[8][12]) {
  int i, j;
  printf("\n");
  for (i = 0; i < 8; ++i) {
    for (j = 0; j < 12; ++j) {
      printf("%c", sklad[i][j]);
    }
    printf("\n");
  }
}

    /* Funkcija za stavljanje novog pravokutnika sa zadanim znakom.
       Koristi se u inicijalizaciji i u (c) dijelu rjesenja. */

void stavi(char sklad[8][12], int pi, int pj, int h, int w, char znak) {
      /* Pretpostavljamo da su koordinate (koje stizu kao argumenti) dobre,
         tj. sva 4 vrha pravokutnika se nalaze unutar zadanog polja! */
  int qi = pi-h+1, qj = pj+w-1;  /* Gornji desni vrh. */
  int i, j;
  for(i = pi; i >= qi; --i) {
    for(j = pj; j <= qj; ++j) {
      sklad[i][j] = znak;
    }
  }
}

    /* ********** Rjesenje ********** */

int moze(char sklad[8][12], int pi, int pj, int h, int w) {
      /* Provjerava moze li se na tu lokaciju staviti
         pravokutnik visine h i sirine w. */
  int qi = pi-h+1, qj = pj+w-1;  /* Gornji desni vrh. */
  int i, j;
      /* Provjera je li gornji desni vrh unutar matrice. */
  if (qi < 0 || qj >= 12) return 0;
      /* Provjera pravokutnika. */
  for(i = pi; i >= qi; --i) {
    for(j = pj; j <= qj; ++j) {
      if (sklad[i][j] != ',')
        return 0;
    }
  }
  return 1;
}

void najveca(char sklad[8][12], int pi, int pj, int *h, int *w) {
      /* Za dane koordinate pi i pj, trazi pravokutnik
         najvece povrsine kojeg mozemo smjestiti na tu lokaciju.
         Vraca visinu/sirinu tog pravokutnika (ako stane).
         Vraca -1 ako nikakav pravokutnik ne stane na lokaciju. */
  int mh = -1, mw = -1, povrsina = -1;
  int hh, ww;

      /* Petlje za visinu hh i sirinu ww. */
  for (hh = 1; pi-hh+1 >= 0; ++hh)
    for (ww = 1; pj+ww-1 < 12; ++ww) {
      if (moze(sklad, pi, pj, hh, ww) && hh*ww > povrsina) {
        povrsina = hh*ww;
        mh = hh;
        mw = ww;
      }
  }

      /* Vrati visinu i sirinu. */
  *h = mh; *w = mw;
  return;
}

void zauzmi(char sklad[8][12], char znak) {
      /* Pronalazi najveci prostor koji se moze popuniti
         i popunjava ga znakom znak. */

      /* Za svaku lokaciju pi i pj, nalazimo dimenzije
         najveceg pravokutnika kojeg mozemo tamo smjestiti.
         Varijable koje pocinju s max pamte podatke
         za najveci od svih tih pravokutnika. */
  int maxi, maxj, maxh, maxw, maxpov = -1;
  int pi, pj, h, w;
  for (pi = 0; pi < 8; ++pi) {
    for(pj = 0; pj < 12; ++pj) {
      najveca(sklad, pi, pj, &h, &w);
      if (h == -1 || w == -1)
        continue;
      if (h*w > maxpov) {
        maxi = pi; maxj = pj;
        maxh = h;  maxw = w;  maxpov = h*w;
      }
    }
  }

  if (maxpov != -1) {
    stavi(sklad, maxi, maxj, maxh, maxw, znak);
  }
}

    /* Glavni program za demo. */

int main(void) {
  char sklad[8][12];
  int k, l;

      /* Inicijalizacija za prvu sliku. */
  inicijaliziraj(sklad);
  stavi(sklad, 1, 3, 2, 4, '$');
  stavi(sklad, 3, 4, 2, 2, '%');
  stavi(sklad, 6, 0, 3, 6, '*');

      /* Slika 1. */
  printf("Pocetno stanje = slika 1:\n");
  printaj(sklad);
  printf("\n");

      /* Pozivi funkcija iz rjesenja zadatka. */
  printf(" moze(sklad, 3, 1, 2, 3) = %d\n",
           moze(sklad, 3, 1, 2, 3));
  printf(" moze(sklad, 3, 1, 3, 3) = %d\n",
           moze(sklad, 3, 1, 3, 3));

  najveca(sklad, 3, 0, &k, &l);
  printf(" najveca(sklad, 3, 0, &k, &l): k = %d, l = %d\n", k, l);

  zauzmi(sklad, '1');

      /* Slika 2. */
  printf("\nStanje nakon zauzmi(sklad, '1') = slika 2:\n");
  printaj(sklad);

  return 0;
}
