/* Zadatak 4C:

  Napisite funkciju ogradi koja prima string opis u kojem je zapisana
  rijec. Funkcija treba provjeriti da li se, u svakom pocetnom komadu
  te rijeci, znak 'e' pojavljuje vise ili jednako puta nego znak 'f',
  pri cemu u cijeloj rijeci treba biti jednak broj znakova 'e' i 'f'.
    Ako to vrijedi, funkcija treba u stringu zamijeniti svaki znak 'e'
  znakom '[', te svaki znak 'f' znakom ']'. U protivnom, funkcija
  ne mijenja string.
    Kao vrijednost, funkcija treba vratiti broj promijenjenih znakova,
  te kroz varijabilni argument pokazivac na promijenjeni znak najveceg
  indeksa, ako takav postoji, inace NULL.
  Ako je string duljine 0, funkcija treba vratiti 0 kao vrijednost, te
  NULL kroz varijabilni argument. Napisite primjer poziva funkcije.

  Primjer: String "-efe-eff" zadovoljava trazeni uvjet, a string
  "-efe-ffe" ne zadovoljava.
*/

#include<stdio.h>

    /* Trazena funkcija iz zadatka. */

int ogradi(char *opis, char **pp_promijenjeni_znak)
{
    int i, broj_pojavljivanja_e = 0, broj_pojavljivanja_f = 0;

    *pp_promijenjeni_znak = NULL;
    if (opis[0] == '\0') return 0;
        /* Obrada pocetnih komada unaprijed, do kraja. */
    for (i = 0; opis[i] != '\0'; ++i) {
        if (opis[i] == 'e') ++broj_pojavljivanja_e;
        if (opis[i] == 'f') ++broj_pojavljivanja_f;
        if (broj_pojavljivanja_e < broj_pojavljivanja_f) return 0;
    }
        /* Promjena znakova. */
    for (i =0; opis[i] != '\0'; ++i) {
        if (opis[i] == 'e')  opis[i] = '[';
        if (opis[i] == 'f') {opis[i] = ']';
            *pp_promijenjeni_znak = &opis[i];
        }
    }

    return broj_pojavljivanja_e + broj_pojavljivanja_f;
}

    /* Glavni program za demo. */

int main (void)
{
    char tekst1[] = "-efe-eff", tekst2[] = "-efe-ffe";
    int n;    /* Vrijednost funkvije. */
    char *p;  /* Pokazivac = varijabilni argument za funkciju. */

        /* Primjer 1. */
    printf("Primjer 1:\n");
    printf("  Rijec prije poziva: %s\n", tekst1);
    n = ogradi(tekst1, &p);
    printf("  Rijec nakon poziva: %s\n", tekst1);
    printf("  Broj promijenjenih znakova = %d\n", n);
    printf("  Adresa pocetka rijeci = %p\n", tekst1);
    printf("  Adresa zadnjeg promijenjenog znaka = %p\n", p);
    if (p != NULL)
        printf("  Indeks zadnje promjene = %d\n", (int)(p - tekst1));

    printf("\n");

        /* Primjer 2. */
    printf("Primjer 2:\n");
    printf("  Rijec prije poziva: %s\n", tekst2);
    n = ogradi(tekst2, &p);
    printf("  Rijec nakon poziva: %s\n", tekst2);
    printf("  Broj promijenjenih znakova = %d\n", n);
    printf("  Adresa pocetka rijeci = %p\n", tekst2);
    printf("  Adresa zadnjeg promijenjenog znaka = %p\n", p);
    if (p != NULL)
        printf("  Indeks zadnje promjene = %d\n", (int)(p - tekst2));

    return 0;
}
